/** SPI_Init.c
 *
 *  Created on: Jan. 17, 2025
 *      Author: Canobby.ca
***/

#include "Periphs.h"
#include "FreeRTOS.h"
#include "task.h"

void Init_SPIs( uint8_t msk ) {

    GPIO_InitTypeDef GPIO_InitStructure = {0};
    SPI_InitTypeDef  SPI_InitStructure = {0};

    					 RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE );
    		printf("InitSPI: Clk GPIOA for 0x%X\n", msk);
    if( msk & SPI2_msk ) RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB, ENABLE );
    if( msk & SPI1_msk ) { RCC_APB2PeriphClockCmd( RCC_APB2Periph_SPI1,  ENABLE );
    	printf("InitSPI: Clk SPI1 for 0x%X\n", msk); }
    if( msk & SPI2_msk ) RCC_APB1PeriphClockCmd( RCC_APB1Periph_SPI2,  ENABLE );
    if( msk & SPI3_msk ) RCC_APB1PeriphClockCmd( RCC_APB1Periph_SPI3,  ENABLE );

    if( msk & SPI1_msk ) { GPIO_InitStructure.GPIO_Pin =  SPI1_MOSI;

//    if( msk & SPI3_msk ) GPIO_InitStructure.GPIO_Pin |= SPI3_MOSI;
//    if( msk & ( SPI1_msk | SPI3_msk )) {
    GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
printf("InitSPI: GPIO pin for 0x%X = %d\n", msk, GPIO_InitStructure.GPIO_Pin ); }
    GPIO_Init(GPIOA, &GPIO_InitStructure);
//    									}

/**   GPIO B SPI2 ???  */

    SPI_SSOutputCmd(SPI1, ENABLE);
    SPI_InitStructure.SPI_Direction = SPI_Direction_1Line_Tx;

    SPI_InitStructure.SPI_Mode = SPI_Mode_Master;

    SPI_InitStructure.SPI_DataSize = SPI_DataSize_16b;
    SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
    SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
//    SPI_InitStructure.SPI_NSS = SPI_NSS_Hard;
    SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_64;  // 96MHz / 64 = 1.5 MHz
    SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_LSB;
    SPI_InitStructure.SPI_CRCPolynomial = 7;
    SPI_Init(SPI1, &SPI_InitStructure);

    SPI1->DATAR = 0;

    SPI_Cmd(SPI1, ENABLE);
}

void SPI_Send( uint16_t dta ) {

	SPI_I2S_SendData(SPI1, dta );
// printf("%X ", dta );
//	Delay_Us( 310 );
//	vTaskDelay(205);

}

